﻿{$Codepage UTF8}
Unit Util;
Interface
  Uses Windows,sysutils;
  Type 
  TSearchRec=Record                  
               Time:Double;  
               Size: Int64;
               Attr: LongInt; //los atributos de busqueda
               Name: UnicodeString; 
               ExcludeAttr: LongInt; //contiene la mascara
               FindHandle: longword; 
               Mode: Longword; //no se usa
               PathOnly: UnicodeString; //no se usa
               FindData : WIN32_FIND_DATAW; 
              End;
    
  Function FileCreate (nombre:UnicodeString):THandle;
  Function FileOpen(nombre:unicodestring;modos:longword):THandle;  
  Function FileExists(nombre:unicodestring):Boolean;  
  Function DirectoryExists(nombre:unicodestring):Boolean;
  Function CreateDir(nombre:unicodestring):Boolean;   
  Function RemoveDir(nombre:unicodestring):Boolean;  
  Function SetCurrentDir(nombre:unicodestring):Boolean;
  Function GetCurrentDir:UnicodeString;
  Function FileGetAttr(nombre:UnicodeString):longword;
  Function FileSetAttr(nombre : unicodestring; atributo:longword):longint;  
  Function FileAge(Nombre:Unicodestring):double;  
  Function FileSetDate(Arch:longint; FechaHora:double):Longint;  
  Function FileSetDate(Nombre:Unicodestring;FechaHora:double):Longint; 
  Function BuscarCoincidencia(Var ResultadoBusq:TSearchRec):Boolean;  
  Procedure PasarParametros(Var ResultadoBusq:TSearchRec);  
  Function FindFirst(Busqueda:UnicodeString;atributos:longword;Var ResultadoBusq:TSearchRec):longint;  
  Function FindNext(Var ResultadoBusq:TSearchRec):longint; 
  Procedure FindClose(Var ResultadoBusq:TSearchRec);  
  Function RenameFile(NombreAnt,NombreNuevo:unicodestring):Boolean;
  Function DeleteFile(Nombre:UnicodeString):Boolean;  
  Function SetDirSeparators(Nombre:UnicodeString):UnicodeString;
  
Implementation
    Function FileCreate (nombre:UnicodeString):THandle;
	begin  
	  FileCreate := CreateFileW(PWidechar(nombre), GENERIC_READ or GENERIC_WRITE,
                                0, nil, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, 0);
    end;
	
	Function FileOpen(nombre:unicodestring;modos:longword):THandle;
	 const
	  ModosApertura: array[0..2] of Longword  = (
		GENERIC_READ,
		GENERIC_WRITE,
		GENERIC_READ or GENERIC_WRITE);
	  ModosCompartir: array[0..6] of Longword = (
		0,0,
		FILE_SHARE_READ,FILE_SHARE_WRITE,
		FILE_SHARE_READ or FILE_SHARE_WRITE,0,0); 
	 Var ModoApertura, ModoCompartir:longword;

	 Begin  
	   ModoApertura:=(modos and $F);
	   ModoCompartir:=(modos shr 4);
	   FileOpen := CreateFileW(PWidechar(nombre),ModosApertura[ModoApertura],
							   ModosCompartir[ModoCompartir],nil,OPEN_EXISTING,
							   FILE_ATTRIBUTE_NORMAL,0);
	 End;
	 
	Function FileExists(nombre:unicodestring):Boolean;
	  var Attr:longword;
	 begin  
	   Attr:=GetFileAttributesW(PWidechar(nombre));  
	   if Attr <> $FFFFFFFF then
		 FileExists:= (Attr and FILE_ATTRIBUTE_DIRECTORY) = 0
	   else
		 FileExists:=False;
	 End;	
	 
	Function DirectoryExists(nombre:unicodestring):Boolean;
	  var Attr:longword;
	 begin  
	   Attr:=GetFileAttributesW(PWidechar(nombre)); //INVALID_FILE_ATTRIBUTES   
	   if Attr <> $FFFFFFFF then
		 DirectoryExists:= (Attr and FILE_ATTRIBUTE_DIRECTORY) <> 0
	   else
		 DirectoryExists:=False;
	 end;	 
	 
	Function CreateDir(nombre:unicodestring):Boolean;
	 Begin
	  CreateDir:=CreateDirectoryW(PWidechar(nombre),nil)
	 End;	
	 
	Function RemoveDir(nombre:unicodestring):Boolean;
   	 Begin
	  RemoveDir:=RemoveDirectoryW(PWidechar(nombre))
	 End;
 
	Function SetCurrentDir(nombre:unicodestring):Boolean;
     Begin
	  SetCurrentDir:=SetCurrentDirectoryW(PWidechar(nombre));
	 End;	
	 
	Function GetCurrentDir:UnicodeString;
     Var URuta:Unicodestring;
		long:longword; 	
	 Begin  
	  GetCurrentDir:='';
	  long:=GetCurrentDirectoryW(0,nil);
	  SetLength(URuta,long);  
	  if GetCurrentDirectoryW(long,PWideChar(URuta)) <> 0 then
		 GetCurrentDir:=URuta;  
	 End;
	 
	Function FileGetAttr(nombre:UnicodeString):longword;
     Begin
	  FileGetAttr:=GetFileAttributesW(PWidechar(nombre));
	 End;
	 
	Function FileSetAttr(nombre : unicodestring; atributo:longword):longint;
	 Begin
	   FileSetAttr:=-1;
	   if SetFileAttributesW(PWidechar(nombre),atributo) then FileSetAttr:=0
	 End;
	 
	Function FileAge(Nombre:Unicodestring):double;
	 Var Arch:Longint;
		 FechaHoraUTC,FechaHoraLocal:FileTime;
		 FechaHoraS:SystemTime;     
	  Begin
		FileAge:=-1;
		Arch:=FileOpen(Nombre,fmOpenReadWrite);
		if GetFileTime(Arch,nil,nil,@FechaHoraUTC) then
		 Begin
		   FileTimeToLocalFileTime(FechaHoraUTC,FechaHoraLocal);
		   FileTimeToSystemTime(FechaHoraLocal,FechaHoraS);
		   FileAge:=SystemTimeToDateTime(FechaHoraS);
		 End;
		FileClose(Arch)
	  End;

	Function FileSetDate(Arch:longint; FechaHora:double):Longint;
	Var FechaHoraUTC,FechaHoraLocal:FileTime;
		FechaHoraS:SystemTime;
	 Begin 
	   FileSetDate:=0;
	   DateTimeToSystemTime(FechaHora,FechaHoraS);
	   SystemTimeToFileTime(FechaHoraS,FechaHoraLocal);
	   LocalFileTimeToFileTime(FechaHoraLocal,FechaHoraUTC);   
	   if SetFileTime(Arch,nil,nil,@FechaHoraUTC) then  FileSetDate:=GetLastError  
	 End;
	 
	Function FileSetDate(Nombre:Unicodestring;FechaHora:double):Longint;
	Var Arch:Longint;
	 Begin
		Arch:=FileOpen(Nombre,fmOpenReadWrite);
		FileSetDate:=FileSetDate(Arch,FechaHora);
		FileClose(Arch)
	 End; 	  
	 
	Function BuscarCoincidencia(Var ResultadoBusq:TSearchRec):Boolean;
	Var encontro:boolean;   
	Begin
	 encontro:=false; 
	 BuscarCoincidencia:=false;
	 While (not encontro) do
	  Begin
		if (ResultadoBusq.FindData.dwFileAttributes and ResultadoBusq.ExcludeAttr)=0 then 
		   Begin
			 encontro:=true;
			 BuscarCoincidencia:=true;
			 PasarParametros(ResultadoBusq);		 
		   End
		else if not FindNextFileW(ResultadoBusq.FindHandle,ResultadoBusq.FindData) then 
				encontro:=true;
	  End; 
	End;  

	Procedure PasarParametros(Var ResultadoBusq:TSearchRec);
	Var 
	 FechaHoraArch : FileTime;     //FileTime de API Win
	 FechaHoraSistema : SystemTime;  //SystemTime de API Win
	Begin
	  FileTimeToLocalFileTime(ResultadoBusq.FindData.ftLastWriteTime,FechaHoraArch); 
	  FileTimeToSystemTime(FechaHoraArch,FechaHoraSistema);  
	  ResultadoBusq.Time:=SystemTimeToDateTime(FechaHoraSistema);

	  ResultadoBusq.size:=ResultadoBusq.FindData.NFileSizeLow+(qword(maxdword)+1)
						  *ResultadoBusq.FindData.NFileSizeHigh;
	  ResultadoBusq.attr:=ResultadoBusq.FindData.dwFileAttributes;
	  ResultadoBusq.Name:=ResultadoBusq.FindData.cFileName;
	End;	

	Function FindFirst(Busqueda:UnicodeString;atributos:longword;
                   Var ResultadoBusq:TSearchRec):longint;
	 Begin
	   ResultadoBusq.ExcludeAttr:=not(atributos or faArchive or faReadOnly);
	   ResultadoBusq.FindHandle:=FindFirstFileW(PWideChar(Busqueda),ResultadoBusq.FindData);
	   FindFirst:=0;
	   If ResultadoBusq.FindHandle<>Invalid_Handle_value then 
		  if Not BuscarCoincidencia(ResultadoBusq) then FindFirst:=GetLastError
	 End;

	Function FindNext(Var ResultadoBusq:TSearchRec):longint;
	Begin    
	  if FindNextFileW(ResultadoBusq.FindHandle,ResultadoBusq.FindData) then  
		if BuscarCoincidencia(ResultadoBusq) then FindNext:=0
	  else FindNext:=GetLastError;
	End;

	Procedure FindClose(Var ResultadoBusq:TSearchRec);
	 Begin
	   Windows.FindClose(ResultadoBusq.FindHandle); 
	 End;

	Function RenameFile(NombreAnt,NombreNuevo:unicodestring):Boolean;
	 Begin  
	   RenameFile:=MoveFileW(PWideChar(NombreAnt),PWideChar(NombreNuevo));
	 End;
	
	Function DeleteFile(Nombre:UnicodeString):Boolean;
	 Begin
	   DeleteFile:=DeleteFileW(PWidechar(Nombre));
	 End;
	 
    Function SetDirSeparators(Nombre:UnicodeString):UnicodeString;	
	 Var i:longword;
	     aux:UnicodeString;
	 Begin
	   aux:=Nombre;
	   for i:=1 to Length(aux) do
        if aux[i] in ['/','\'] then
          aux[i]:=DirectorySeparator;
	   SetDirSeparators:=aux	  
	 End;
Begin
End.